<html>
<head>
<title>OGRE: OgreSerializer.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreSerializer.h</h1><a href="OgreSerializer_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#ifndef __Serializer_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#define __Serializer_H__</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreString_8h.html">OgreString.h</a>"</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreDataStream_8h.html">OgreDataStream.h</a>"</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre {
<a name="l00038"></a>00038 
<a name="l00044"></a><a class="code" href="classOgre_1_1Serializer.html">00044</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Serializer.html" title="Generic class for serialising data to / from binary stream-based files.">Serializer</a>
<a name="l00045"></a>00045     {
<a name="l00046"></a>00046     <span class="keyword">public</span>:
<a name="l00047"></a>00047         <a class="code" href="classOgre_1_1Serializer.html" title="Generic class for serialising data to / from binary stream-based files.">Serializer</a>();
<a name="l00048"></a>00048         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1Serializer.html" title="Generic class for serialising data to / from binary stream-based files.">Serializer</a>();
<a name="l00049"></a>00049 
<a name="l00051"></a><a class="code" href="classOgre_1_1Serializer.html#5122d5a3161fb5fd819d9a0521fe9d39">00051</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1Serializer.html#5122d5a3161fb5fd819d9a0521fe9d39" title="The endianness of written files.">Endian</a>
<a name="l00052"></a>00052         {
<a name="l00054"></a><a class="code" href="classOgre_1_1Serializer.html#5122d5a3161fb5fd819d9a0521fe9d39ed60ca999861d8939cf57f19090c70ef">00054</a>             ENDIAN_NATIVE,
<a name="l00056"></a><a class="code" href="classOgre_1_1Serializer.html#5122d5a3161fb5fd819d9a0521fe9d397f044c7683a7374276db6e7060f51240">00056</a>             ENDIAN_BIG,
<a name="l00058"></a><a class="code" href="classOgre_1_1Serializer.html#5122d5a3161fb5fd819d9a0521fe9d3910ce3b8f55cba526f6bc8237d8b25cc3">00058</a>             ENDIAN_LITTLE
<a name="l00059"></a>00059         };
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a>00062     <span class="keyword">protected</span>:
<a name="l00063"></a>00063 
<a name="l00064"></a><a class="code" href="classOgre_1_1Serializer.html#6331ceec847b83fed77165c9522eaa4f">00064</a>         <a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a> mCurrentstreamLen;
<a name="l00065"></a><a class="code" href="classOgre_1_1Serializer.html#adee4932c73bfbcb3104245bbba4b50f">00065</a>         FILE* mpfFile;
<a name="l00066"></a><a class="code" href="classOgre_1_1Serializer.html#45b8d6fa3d3c64b3ab3dfe3a5084e3b4">00066</a>         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> mVersion;
<a name="l00067"></a><a class="code" href="classOgre_1_1Serializer.html#a0773a2ca956fa2864ac50f57d0aa9a2">00067</a>         <span class="keywordtype">bool</span> mFlipEndian; <span class="comment">// default to native endian, derive from header</span>
<a name="l00068"></a>00068 
<a name="l00069"></a>00069         <span class="comment">// Internal methods</span>
<a name="l00070"></a>00070         <span class="keyword">virtual</span> <span class="keywordtype">void</span> writeFileHeader(<span class="keywordtype">void</span>);
<a name="l00071"></a>00071         <span class="keyword">virtual</span> <span class="keywordtype">void</span> writeChunkHeader(<a class="code" href="namespaceOgre.html#a8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <span class="keywordtype">id</span>, <span class="keywordtype">size_t</span> size);
<a name="l00072"></a>00072         
<a name="l00073"></a>00073         <span class="keywordtype">void</span> writeFloats(<span class="keyword">const</span> <span class="keywordtype">float</span>* <span class="keyword">const</span> pfloat, <span class="keywordtype">size_t</span> count);
<a name="l00074"></a>00074         <span class="keywordtype">void</span> writeFloats(<span class="keyword">const</span> <span class="keywordtype">double</span>* <span class="keyword">const</span> pfloat, <span class="keywordtype">size_t</span> count);
<a name="l00075"></a>00075         <span class="keywordtype">void</span> writeShorts(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>* <span class="keyword">const</span> pShort, <span class="keywordtype">size_t</span> count);
<a name="l00076"></a>00076         <span class="keywordtype">void</span> writeInts(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a>* <span class="keyword">const</span> pInt, <span class="keywordtype">size_t</span> count); 
<a name="l00077"></a>00077         <span class="keywordtype">void</span> writeBools(<span class="keyword">const</span> <span class="keywordtype">bool</span>* <span class="keyword">const</span> pLong, <span class="keywordtype">size_t</span> count);
<a name="l00078"></a>00078         <span class="keywordtype">void</span> writeObject(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vec);
<a name="l00079"></a>00079         <span class="keywordtype">void</span> writeObject(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; q);
<a name="l00080"></a>00080         
<a name="l00081"></a>00081         <span class="keywordtype">void</span> writeString(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <span class="keywordtype">string</span>);
<a name="l00082"></a>00082         <span class="keywordtype">void</span> writeData(<span class="keyword">const</span> <span class="keywordtype">void</span>* <span class="keyword">const</span> buf, <span class="keywordtype">size_t</span> size, <span class="keywordtype">size_t</span> count);
<a name="l00083"></a>00083         
<a name="l00084"></a>00084         <span class="keyword">virtual</span> <span class="keywordtype">void</span> readFileHeader(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a>&amp; stream);
<a name="l00085"></a>00085         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> readChunk(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a>&amp; stream);
<a name="l00086"></a>00086         
<a name="l00087"></a>00087         <span class="keywordtype">void</span> readBools(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a>&amp; stream, <span class="keywordtype">bool</span>* pDest, <span class="keywordtype">size_t</span> count);
<a name="l00088"></a>00088         <span class="keywordtype">void</span> readFloats(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a>&amp; stream, <span class="keywordtype">float</span>* pDest, <span class="keywordtype">size_t</span> count);
<a name="l00089"></a>00089         <span class="keywordtype">void</span> readFloats(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a>&amp; stream, <span class="keywordtype">double</span>* pDest, <span class="keywordtype">size_t</span> count);
<a name="l00090"></a>00090         <span class="keywordtype">void</span> readShorts(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a>&amp; stream, <a class="code" href="namespaceOgre.html#a8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>* pDest, <span class="keywordtype">size_t</span> count);
<a name="l00091"></a>00091         <span class="keywordtype">void</span> readInts(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a>&amp; stream, <a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a>* pDest, <span class="keywordtype">size_t</span> count);
<a name="l00092"></a>00092         <span class="keywordtype">void</span> readObject(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a>&amp; stream, <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; pDest);
<a name="l00093"></a>00093         <span class="keywordtype">void</span> readObject(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a>&amp; stream, <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; pDest);
<a name="l00094"></a>00094 
<a name="l00095"></a>00095         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> readString(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a>&amp; stream);
<a name="l00096"></a>00096         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> readString(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a>&amp; stream, <span class="keywordtype">size_t</span> numChars);
<a name="l00097"></a>00097         
<a name="l00098"></a>00098         <span class="keyword">virtual</span> <span class="keywordtype">void</span> flipToLittleEndian(<span class="keywordtype">void</span>* pData, <span class="keywordtype">size_t</span> size, <span class="keywordtype">size_t</span> count = 1);
<a name="l00099"></a>00099         <span class="keyword">virtual</span> <span class="keywordtype">void</span> flipFromLittleEndian(<span class="keywordtype">void</span>* pData, <span class="keywordtype">size_t</span> size, <span class="keywordtype">size_t</span> count = 1);
<a name="l00100"></a>00100         
<a name="l00101"></a>00101         <span class="keyword">virtual</span> <span class="keywordtype">void</span> flipEndian(<span class="keywordtype">void</span> * pData, <span class="keywordtype">size_t</span> size, <span class="keywordtype">size_t</span> count);
<a name="l00102"></a>00102         <span class="keyword">virtual</span> <span class="keywordtype">void</span> flipEndian(<span class="keywordtype">void</span> * pData, <span class="keywordtype">size_t</span> size);
<a name="l00103"></a>00103 
<a name="l00105"></a>00105         <span class="keyword">virtual</span> <span class="keywordtype">void</span> determineEndianness(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a>&amp; stream);
<a name="l00107"></a>00107         <span class="keyword">virtual</span> <span class="keywordtype">void</span> determineEndianness(<a class="code" href="classOgre_1_1Serializer.html#5122d5a3161fb5fd819d9a0521fe9d39" title="The endianness of written files.">Endian</a> requestedEndian);
<a name="l00108"></a>00108     };
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 }
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:56 2008
</p>
</body>
</html>
